/* Almost compliant identd by  Stephen Loomis
   returns  USER enviroment variable to ALL connecting querys */

#include <types.h>
#include <netinet\in.h>
#include <sys\socket.h>
#include <sys\select.h>
#include <netdb.h>
#include <stdio.h>

#include <nerrno.h>
#include <ctype.h>


#define BUFSIZE         1024

#ifndef errno
extern int errno;
#endif



int conn_socket;           /* also the line number */
short conn_port;           /* port number on remote host */
char conn_onfrom[50];      /* where they are on from */



int sock;       /* our initial socket */
int conn;       /* connection */

char recvbuf[BUFSIZE], sendbuf[BUFSIZE], userbuf[BUFSIZE];


void main()
{
   char *buf, check;

   buf = (char *)getenv("USER");

   check = (char)buf;
   sprintf(userbuf,"proxy-");

   doit(113); /* Start the daemon with port 113 ( the IDENTD socket ) */

}
	



int
    doit(port)
int port;
{

    fd_set needread;        /* for seeing which fds we need to read from */


    sock = getsock(sendbuf, port);

    printf("ͻ\r\n");
    printf("    (identd.exe)  v2.1     \r\n");
    printf("  compiled with Cset v2.1  \r\n");
    printf("     os2 2.1 compatible    \r\n");
    printf("  (c) 1995 Stephen Loomis  \r\n");
    printf("ͼ\r\n");


    while (1 == 1)
        {
         FD_ZERO(&needread);
         FD_SET(sock, &needread);
         if (select(sizeof(fd_set), &needread, (fd_set *)0,
              (fd_set *)0, (struct timeval *)0) == -1)
           {
            if (errno != EINTR)
                {
                 continue;
                }
            else
             continue; /* do it again and get it right */
           }
	
        if (FD_ISSET(sock, &needread))
        {
         conn = newconn(sock);
        }
 
    }
}


int newconn(s)
int s;
{
    int port, count=0;

    
    conn_socket = acceptcon(s, conn_onfrom, &port);
    conn_port = port;


    if ( infromsock(conn_socket, recvbuf, BUFSIZE) == -1)
                 {
                  /* they logged off */

                  shutdown(conn_socket, 2);
                  (void) soclose(conn_socket);
                  return 0;
                 }

    for ( count=0; count<BUFSIZE; count++)
        {
         if ( (recvbuf[count] == '\r')||(recvbuf[count] == '\n') )
            {
             recvbuf[count] = '\000';
             break;
            }
        }

    sprintf(sendbuf,"%s: USERID: OS/2: %s%d\r\n",recvbuf,userbuf,conn_socket);

    if (outtosock(conn_socket, sendbuf) == -1)
       { /* no one there */
        shutdown(conn_socket, 2);
        (void) soclose(conn_socket);
       }

    shutdown(conn_socket, 2);
    (void) soclose(conn_socket);

    return 0;
}


int
    getsock(address, port)
char *address;
int port;
{
    int s,one = 1;
    struct in_addr tmpaddr;
    struct hostent *tmphost;
    struct sockaddr_in saddr;
    
    /* get a fresh socket */
    if ((s = socket(AF_INET, SOCK_STREAM, 0)) == -1) {

    perror("\a");

    exit(errno);
    }
    
    saddr.sin_port = (unsigned short) htons((unsigned short) port);

    saddr.sin_addr.s_addr = INADDR_ANY;
    saddr.sin_family = AF_INET;
    setsockopt(s, SOL_SOCKET, SO_REUSEADDR, (char *)&one, sizeof(one));

    /* attempt to bind the socket to our address */
    if (bind(s, (struct sockaddr *) &saddr, sizeof(struct sockaddr_in)) == -1)
	{

        perror("\a");

        exit(errno);
	}

    one = sizeof(struct sockaddr_in);
    getsockname(s,&saddr,&one );
    printf("%d %d socket\r\n",s,htons(saddr.sin_port));
    /* set our backlog of waiting connections to 5(max the system allows) */
    if (listen(s, 5) == -1) {

    perror("\a");

    exit(errno);
    }
    
    return s;
}

int
    acceptcon(s, from, port)
int s;
char *from;
int *port;
{
    int ns;
    int length = sizeof(struct sockaddr_in);
    char *buf;
    struct hostent *tmphost;
    struct sockaddr_in saddr;
    
    if ((ns = accept(s, (struct sockaddr *) &saddr, &length)) == -1) {


	return -1;
    }
    
    
    tmphost = gethostbyaddr((char *) &(saddr.sin_addr),
			    sizeof(struct in_addr), AF_INET);
    if (tmphost == (struct hostent *)0) {


	(void) strcpy(from, "UNKNOWN");
	(void) strcpy(from, inet_ntoa(saddr.sin_addr));
    } else {
	buf = tmphost->h_name;
	if (buf != (char *)0) {
	    (void) strcpy(from, buf);
	} else
	    (void) strcpy(from, inet_ntoa(saddr.sin_addr));
    } 
    *port = ntohs(saddr.sin_port);
    
    return ns;
}

int
  infromsock(s, buffer, size)
int s;
char *buffer;
int size;
{
  int numchars;
  
  if ((numchars = recv(s, buffer, size-1, 0x0)) <= 0 ) { /* panic for now */


    if( errno == 12 )
	return 0;
    else
	return -1;
  }
  
  if (numchars == 0) { /* foreign end closed the connection be graceful */
    return -1; /* tell the calling proc to deal with it. */
  }

  buffer[numchars] = '\000';
  return 0;
}

int
  outtosock(s, buffer)
int s;
char *buffer;
{
  int length, numsent;
  
  length = strlen(buffer);
  if ((numsent = send(s, buffer, length, 0x0)) == -1) {


    return -1;
  } else if (numsent < length) {


  }
  
  return 0;
}
